
#    MIDAS Access Client  for  CAMAC

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global CAMACAccessServerHost CAMACAccessServerPort

if {[info exists CAMACAccessServerHost] == 0} then {set CAMACAccessServerHost localhost}
if {[info exists CAMACAccessServerPort] == 0} then {set CAMACAccessServerPort 8015}

variable uri "urn:CAMACAccessServer"
variable proxy "http://$CAMACAccessServerHost:$CAMACAccessServerPort/CAMACAccessServer"

SOAP::create DefineRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string Class string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create InquireRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create ReadRegisterAttributes -proxy $proxy -uri $uri -timeout 5000 -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create ReadRegistersAttributes -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create DeleteRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create DeleteRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create WriteRegisterAttributes -proxy $proxy -uri $uri -timeout 5000 -params {Register string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create WriteRegistersAttributes -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create WriteRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create WriteRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create InitialiseRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create InitialiseRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create ReadRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create ReadRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create InterfaceStatus -proxy $proxy -uri $uri -timeout 5000 -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create AccessServerVerbose -proxy $proxy -uri $uri -timeout 5000 -params {opt string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 


package provide CAMACAccessClient 1.0
