



set EGreport 0
set EGallow  0xffffffff
set EGallowAll 0x0
set EGRetry 0
set EGRetries 0
set EGcommand ""

proc EGOnce {x} {
   global env tkskiperror EGreport EGallow EGallowAll EGRetry EGcommand
   if {$EGreport >= 3} then {insert-debug "executing: $x"}
   if {$EGreport >= 2} then {set-footer "executing: $x"}
   if {$EGreport == 1} then {set-footer "accessing [third $x]"}
   if {$EGreport >= 0} then {frame-busy}
   set NoError 0
   set z [catch {__eg "$x"} m]
   if {$EGreport >= 3} then {insert-debug "reply: $z $m"}
   if {$z != 0 && $EGallow != $EGallowAll} then {
      if {$m != $EGallow} then {
        switch -glob  $m {
            0x1001c -
            0x*ffff {
                set EGcommand $x
                set EGServer [first $EGcommand]
                set EGserver [second [split [third $EGcommand] /]]
                if {$EGRetry == 0} then {
                    midas-warning "Network timeout executing the [first $EGServer] server access \
command\n\n$x\n\n\nThe server $EGserver could not be contacted.\nIf the problem continues check \
the network path to the server and check the server itself.\nIf the server has crashed you should restart it."
                } else {
                    set NoError 1
                }
            }
            default {display-midas-error-report self $m "executing: $x"}
        }
        set tkskiperror 1
      }
      if {$EGreport >= 0} then {frame-idle}
      if {$EGreport >= 1} then {clear-footer}
      if {$m != $EGallow && $NoError == 0} then {error $m}
   }
   if {$EGreport >= 0} then {frame-idle}
   if {$EGreport >= 1} then {clear-footer}
   return "$m"
}

proc EG {x} {
    global EGRetry EGRetries
    set EGRetry [expr $EGRetries + 1]
    while {$EGRetry > 0} {
        incr EGRetry -1
        set m [EGOnce $x]
    }
    return "$m"
}


#    special bindings which may be envoked

proc EGbindings {} {

  bind all <Control-Alt-KeyPress-0> "global EGreport; set EGreport 0"
  bind all <Control-Alt-KeyPress-1> "global EGreport; set EGreport 1"
  bind all <Control-Alt-KeyPress-2> "global EGreport; set EGreport 2"
  bind all <Control-Alt-KeyPress-3> "global EGreport; set EGreport 3"
}

proc write-register       {r v} {global RegisterServer; EG "register :name    '/$RegisterServer/$r' :value '$v'"}
proc write-registers      {r v} {global RegisterServer; EG "register :pattern '/$RegisterServer/$r' :value '$v'"}
proc read-register        {r}   {global RegisterServer; EG "register :name    '/$RegisterServer/$r' ?value"}
proc read-registers       {r}   {global RegisterServer; EG "register :pattern '/$RegisterServer/$r' ?names-and-values"}
proc write-attributes     {r v} {global RegisterServer; EG "register :name    '/$RegisterServer/$r' :object '$v'"}
proc read-attributes      {r}   {global RegisterServer; EG "register :name    '/$RegisterServer/$r' ?object"}
proc initialise-register  {r}   {global RegisterServer; EG "register :name    '/$RegisterServer/$r' !initialise"}
proc initialise-registers {r}   {global RegisterServer; EG "register :pattern '/$RegisterServer/$r' !initialise"}
proc define-register {class name attributes} {
   global RegisterServer

   set register /$RegisterServer/$name
   EG "register :pattern '$register' !delete"
   EG "register :name '$register' :class '$class' !new"
   EG "register :name '$register' :object '$attributes'"
}

proc __eg {arg} {
    global MIDASAccessServer

#    this takes the old EG command argument string and converts into the new format


   insert-debug "__eg received args    $arg"

#    We need to replace ' characters in the old syntax with " characters

    regsub -all ' $arg \" 

   set Querys 0
   set Actions 0
   set Values 0
   set Names 0
   set Patterns 0
   set Paths 0
   set Classes 0
   set Objects 0

   set Action ""
   set Query ""
   set Execute ""

   switch [first $arg] {

       register {

          set Cmd [regsub -all ' [tail $arg] \"]

          set i 0
          while {$i < [llength $Cmd]} {
            set p [lindex $Cmd $i]
            incr i

            switch $p {

                :name     {set Name [lindex $Cmd $i]; incr Names; incr i}
                :pattern  {set Name [lindex $Cmd $i]; incr Patterns; incr i}
                :class    {set Class [lindex $Cmd $i]; incr Classes; incr i}

                :timeout  {incr i}

                :value    {set Execute $p; set Value "[lindex $Cmd $i]"; incr Values; incr i}
                :object   {set Execute $p; set Value "[lindex $Cmd $i]"; incr Objects; incr i}

                ?names  -
                ?value -
                ?names-and-values -
                ?object -
                ?names-and-objects -
                ?names-and-classes -
                ?class    {set Query $p; incr Querys}

                !new -
                !delete -
                !initialise -
                !ping     {set Action $p; incr Actions;}

                default {error "Invalid token: $p"}
            }
          }

          if {$Actions > 1} {error "More than 1 action token: $Cmd"}
          if {$Querys > 1} {error "More than 1 query token: $Cmd"}
          if {[expr $Actions + $Querys + $Values +$Objects] != 1} {error "Command structure error: $Cmd"}

          if {[expr $Names + $Patterns] != 1} {error "Command structure error: $Cmd"}

          if {$Classes > 1} {error "More than 1 :class token: $Cmd"}
          if {$Objects > 1} {error "More than 1 :object token: $Cmd"}
          if {$Values > 1} {error "More than 1 :value token: $Cmd"}

          if {[expr $Actions + $Querys] == 0 && [expr $Values + $Objects] != 1} {error "Command structure error: $Cmd"}


#    look at :name or :pattern token (one must be present) and extract the server

          if {[llength [split $Name /]] == 3} then {     ;#  format is  /server/register
              set server [second [split $Name /]]
              set register [third [split $Name /]]
          } else {
              set server $MIDASAccessServer     ;#  default
              set register $Name
          }

          switch $Action {

             !new {
                 if {[expr $Names + $Classes] != 2} {error "Command structure error: $Cmd"}
                 set rc [MIDASDefineRegister /$server/$register $Class ""]
             }

             !delete {
                 if {$Names == 1} then {
                     set rc [MIDASDeleteRegister /$server/$register]
                 } else {
                     set rc [MIDASDeleteRegisters /$server/$register]
                 }
insert-debug "!delete returns $rc"
             }

             !initialise {
                 if {$Names == 1} then {
                     set rc [MIDASInitialiseRegister /$server/$register]
                 } else {
                     set rc [MIDASInitialiseRegisters /$server/$register]
                 }

             }

             !ping {}
          }

          switch $Query {

              ?names {
                  set rc [MIDASInquireRegisters /$server/$register]
              }

              ?value {
                  set rc [MIDASReadRegister /$server/$register]
              }

              ?object {
                  set rc [MIDASReadRegisterAttributes /$server/$register]
              }

              ?class {
                  set rc [MIDASReadRegisterClass /$server/$register]
              }

              ?names-and-values {
                  set rc [MIDASReadRegisters /$server/$register]
              }

              ?names-and-objects {
                  set rc [MIDASReadRegistersAttributes /$server/$register]
              }

              ?names-and-classes {
                  set rc [MIDASReadRegistersClasses /$server/$register]
              }

          }

          switch $Execute {

              :value {
                 if {$Names == 1} then {
                     set rc [MIDASWriteRegister /$server/$register $Value]
                 } else {
                     set rc [MIDASWriteRegisters /$server/$register $Value]
                 }

              }

              :object {
                 if {$Names == 1} then {
                     set rc [MIDASWriteRegisterAttributes /$server/$register $Value]
                 } else {
                     set rc [MIDASWriteRegistersAttributes /$server/$register $Value]
                 }

              }

          }

          return $rc

       }

       tape {insert-debug "$args not implemented at present"}

       spectrum {insert-debug "$args not implemented at present"}

       default {insert-debug "$args not understood"}

   }

}



proc MIDASRegisterAccess {Method Name args} {
    global MIDASAccessServer

insert-debug "MIDASRegisterAccess: $Method $Name [llength $args] $args"

#    look at the Name argument and split into server + register

      if {[llength [split $Name /]] == 3} then {     ;#  format is  /server/register
          set server [second [split $Name /]]
          set register [third [split $Name /]]
      } else {
          set server $MIDASAccessServer     ;#  default
          set register $Name
      }

#    start to determine the access method
#    server is either an apparatus Role or is the name of a specific apparatus

#    first try legacy RPC servers

     set RPCservers [inform ex obtain_RPCServer_byRole $server]   ;# Role gets priority
     if {$RPCservers == ""} then {set RPCservers [inform ex obtain_RPCServer_byName $server]}

#    then try SOAP/XML servers

     set SOAPservers [inform ex obtain_SOAPServer_byRole $server]   ;# Role gets priority
     if {$SOAPservers == ""} then {set SOAPservers [inform ex obtain_SOAPServer_byName $server]}

     if {$SOAPservers == "" && $RPCservers == ""} {
         return -code error -errorcode 0x10002  -errorinfo "no suitable resource available" 0x10002
     }

insert-debug "RPCservers=$RPCservers; SOAPservers=$SOAPservers"

     if {$SOAPservers == ""} then {    ;# if no SOAP servers use legacy RPC method

insert-debug "Using RPC $Method /$server/$register"

        switch $Method  {
            DefineRegister           {
                set reply [eg "(register :name    '/$server/$register' :class '[first $args]' !new)"]
                return $reply
            }

            WriteRegister            {return [eg "(register :name    '/$server/$register' :value  '$args')"]}
            WriteRegisterAttributes  {return [eg "(register :name    '/$server/$register' :object '$args')"]}

            WriteRegisters           {return [eg "(register :pattern '/$server/$register' :value  '$args')"]}
            WriteRegistersAttributes {return [eg "(register :pattern '/$server/$register' :object '$args')"]}

            InitialiseRegister       {return [eg "(register :name    '/$server/$register' !initialise)"]}
            DeleteRegister           {return [eg "(register :name    '/$server/$register' !delete)"]}

            InitialiseRegisters      {return [eg "(register :pattern '/$server/$register' !initialise)"]}
            DeleteRegisters          {return [eg "(register :pattern '/$server/$register' !delete)"]}

            ReadRegister             {return [eg "(register :name    '/$server/$register' ?value)"]}
            ReadRegisterAttributes   {return [eg "(register :name    '/$server/$register' ?object)"]}
            ReadRegisterClass        {return [eg "(register :name    '/$server/$register' ?class)"]}

            InquireRegisters         {return [eg "(register :pattern '/$server/$register' ?names)"]}
            ReadRegisters            {return [eg "(register :pattern '/$server/$register' ?names-and-values)"]}
            ReadRegistersAttributes  {return [eg "(register :pattern '/$server/$register' ?names-and-objects)"]}
            ReadRegistersClasses     {return [eg "(register :pattern '/$server/$register' ?names-and-classes)"]}
        }
     }

     if {$RPCservers == ""} then {    ;# if no RPC servers use SOAP method

         set rc ""

         foreach SOAPserver $SOAPservers {

             set Urn   [inform ex obtain_SOAPServer_Urn $SOAPserver]
             set Class [inform ex obtain_SOAPServer_Class $SOAPserver]
             set Cmd   [inform ex obtain_SOAPServer_Cmd $SOAPserver]

insert-debug "Using SOAP server $SOAPserver $Cmd  $Method $Urn  $register  $args"

         package require $Cmd

             SOAP::configure [set Cmd]__$Method -proxy "http://$SOAPserver/$Urn" -uri "urn:$Urn"

             switch $Method  {
                DefineRegister           {
                    set reply [[set Cmd]__$Method $register [first $args] "[second $args]"]
                    if {[first $reply] == 0} then {return 0}
                    set rc [first $reply]
                }

                WriteRegister            -
                WriteRegisterAttributes  {
                    set reply [[set Cmd]__$Method $register "[first $args]"]
                    if {[first $reply] == 0} then {return 0}
                    set rc [first $reply]
                }

                WriteRegisters           -
                WriteRegistersAttributes {set reply [[set Cmd]__$Method $register "[first $args]"]; set rc 0}

                InitialiseRegister       -
                DeleteRegister           {
                    set reply [[set Cmd]__$Method $register]
                    if {[first $reply] == 0} then {return 0}
                    set rc [first $reply]
                }

                InitialiseRegisters      -
                DeleteRegisters          {set reply [[set Cmd]__$Method $register]; set rc 0}


                ReadRegister             -
                ReadRegisterAttributes   -
                ReadRegisterClass        {
                    set reply [[set Cmd]__$Method $register]
                    if {[first $reply] == 0} then {return [second $reply]}
                    set rc [first $reply]
                }

                InquireRegisters         -
                ReadRegisters            -
                ReadRegistersAttributes  -
                ReadRegistersClasses     {
                    set reply [[set Cmd]__$Method $register]
                    if {[first $reply] == 0} then {append rc [second $reply]}
                }
             }
insert-debug "reply=$reply"       ;#   get  rc   text message
         }

         return $rc       ;#  done it
     }


#    Try both RPC and SOAP servers

     set rc ""

insert-debug "Using RPC $Method /$server/$register"

        switch $Method  {
            DefineRegister           {set z [catch {eg "(register :name    '/$server/$register' :class '[first $args]' !new)"} m]}

            WriteRegister            {set z [catch {eg "(register :name    '/$server/$register' :value  '$args')"} m]}
            WriteRegisterAttributes  {set z [catch {eg "(register :name    '/$server/$register' :object '$args')"} m]}

            WriteRegisters           {set z [catch {eg "(register :pattern '/$server/$register' :value  '$args')"} m]}
            WriteRegistersAttributes {set z [catch {eg "(register :pattern '/$server/$register' :object '$args')"} m]}

            InitialiseRegister       {set z [catch {eg "(register :name    '/$server/$register' !initialise)"} m]}
            DeleteRegister           {set z [catch {eg "(register :name    '/$server/$register' !delete)"} m]}

            InitialiseRegisters      {set z [catch {eg "(register :pattern '/$server/$register' !initialise)"} m]}
            DeleteRegisters          {set z [catch {eg "(register :pattern '/$server/$register' !delete)"} m]}

            ReadRegister             {set z [catch {eg "(register :name    '/$server/$register' ?value)"} m]}
            ReadRegisterAttributes   {set z [catch {eg "(register :name    '/$server/$register' ?object)"} m]}
            ReadRegisterClass        {set z [catch {eg "(register :name    '/$server/$register' ?class)"} m]}

            InquireRegisters         {set z [catch {eg "(register :pattern '/$server/$register' ?names)"} m]}
            ReadRegisters            {set z [catch {eg "(register :pattern '/$server/$register' ?names-and-values)"} m]}
            ReadRegistersAttributes  {set z [catch {eg "(register :pattern '/$server/$register' ?names-and-objects)"} m]}
            ReadRegistersClasses     {set z [catch {eg "(register :pattern '/$server/$register' ?names-and-classes)"} m]}
        }


           switch $Method  {
                DefineRegister           -
                WriteRegister            -
                WriteRegisterAttributes  -
                InitialiseRegister       -
                DeleteRegister           {
                    if {$z == 0} then {return 0}
                    set rc $m
                }

                WriteRegisters           -
                WriteRegistersAttributes -
                InitialiseRegisters      -
                DeleteRegisters          {set rc 0}

                ReadRegister             -
                ReadRegisterAttributes   -
                ReadRegisterClass        -
                InquireRegisters         -
                ReadRegisters            -
                ReadRegistersAttributes  -
                ReadRegistersClasses     {
                    if {$z == 0} then {append $rc $m}
                }
            }


         foreach SOAPserver $SOAPservers {

             set Urn   [inform ex obtain_SOAPServer_Urn $SOAPserver]
             set Class [inform ex obtain_SOAPServer_Class $SOAPserver]
             set Cmd   [inform ex obtain_SOAPServer_Cmd $SOAPserver]

insert-debug "Using SOAP server $SOAPserver $Cmd  $Method $Urn  $register  $args"

         package require $Cmd

             SOAP::configure [set Cmd]__$Method -proxy "http://$SOAPserver/$Urn" -uri "urn:$Urn"


             switch $Method  {
                DefineRegister           {
                    set reply [[set Cmd]__$Method $register [first $args] "[second $args]"]
                    if {[first $reply] == 0} then {return 0}
                    set rc [first $reply]
                }

                WriteRegister            -
                WriteRegisterAttributes  {
                    set reply [[set Cmd]__$Method $register "[first $args]"]
                    if {[first $reply] == 0} then {return 0}
                    set rc [first $reply]
                }

                WriteRegisters           -
                WriteRegistersAttributes {set reply [[set Cmd]__$Method $register "[first $args]"]; set rc 0}

                InitialiseRegister       -
                DeleteRegister           {
                    set reply [[set Cmd]__$Method $register]
                    if {[first $reply] == 0} then {return 0}
                    set rc [first $reply]
                }

                InitialiseRegisters      -
                DeleteRegisters          {set reply [[set Cmd]__$Method $register]; set rc 0}


                ReadRegister             -
                ReadRegisterAttributes   -
                ReadRegisterClass        {
                    set reply [[set Cmd]__$Method $register]
                    if {[first $reply] == 0} then {return [second $reply]}
                    set rc [first $reply]
                }

                InquireRegisters         -
                ReadRegisters            -
                ReadRegistersAttributes  -
                ReadRegistersClasses     {
                    set reply [[set Cmd]__$Method $register]
                    if {[first $reply] == 0} then {append rc [second $reply]}
                }
             }
insert-debug "$reply"       ;#   get  rc   text message
         }

     return $rc       ;#  done it

     return -code error -errorcode 0x10004  -errorinfo "register not known" 0x10004
}


proc MIDASDeleteRegister            {Name}            {return [MIDASRegisterAccess DeleteRegister $Name]}
proc MIDASDeleteRegisters           {Name}            {return [MIDASRegisterAccess DeleteRegisters $Name]}
proc MIDASWriteRegister             {Name Value}      {return [MIDASRegisterAccess WriteRegister $Name "$Value"]}
proc MIDASWriteRegisters            {Name Value}      {return [MIDASRegisterAccess WriteRegisters $Name "$Value"]}
proc MIDASInitialiseRegister        {Name}            {return [MIDASRegisterAccess InitialiseRegister $Name]}
proc MIDASInitialiseRegisters       {Name}            {return [MIDASRegisterAccess InitialiseRegisters $Name]}
proc MIDASWriteRegisterAttributes   {Name Attributes} {return [MIDASRegisterAccess WriteRegisterAttributes $Name "$Attributes"]}
proc MIDASWriteRegistersAttributes  {Name Attributes} {return [MIDASRegisterAccess WriteRegistersAttributes $Name "$Attributes"]}
proc MIDASInquireRegisters          {Name}            {return [MIDASRegisterAccess InquireRegisters $Name]}
proc MIDASReadRegister              {Name}            {return [MIDASRegisterAccess ReadRegister $Name]}
proc MIDASReadRegisters             {Name}            {return [MIDASRegisterAccess ReadRegisters $Name]}
proc MIDASReadRegisterAttributes    {Name}            {return [MIDASRegisterAccess ReadRegisterAttributes $Name]}
proc MIDASReadRegistersAttributes   {Name}            {return [MIDASRegisterAccess ReadRegistersAttributes $Name]}
proc MIDASReadRegisterClass         {Name}            {return [MIDASRegisterAccess ReadRegisterClass $Name]}
proc MIDASReadRegistersClasses      {Name}            {return [MIDASRegisterAccess ReadRegistersClasses $Name]}
proc MIDASDefineRegister            {Name Class Attributes}  {return [MIDASRegisterAccess DefineRegister $Name $Class "$Attributes"]}

