
#    MIDAS Access Client  for the SigTask service

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global SigTaskServerHost SigTaskServerPort

if {[info exists SigTaskServerHost] == 0} then {set SigTaskServerHost localhost}
if {[info exists SigTaskServerPort] == 0} then {set SigTaskServerPort 8015}

variable uri "urn:SigTaskServer"
variable proxy "http://$SigTaskServerHost:$SigTaskServerPort/SigTaskServer"

SOAP::create DefineRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string Class string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create InquireRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create ReadRegisterAttributes -proxy $proxy -uri $uri -timeout 5000 -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create ReadRegistersAttributes -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create DeleteRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create DeleteRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create WriteRegisterAttributes -proxy $proxy -uri $uri -timeout 5000 -params {Register string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create WriteRegistersAttributes -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create WriteRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create WriteRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create InitialiseRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create InitialiseRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create ReadRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create ReadRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 


package provide SigTaskClient 1.0
