

#    MIDAS Access Client  for  VME

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global VMEAccessServerHost VMEAccessServerPort

if {[info exists VMEAccessServerHost] == 0} then {set VMEAccessServerHost localhost}
if {[info exists VMEAccessServerPort] == 0} then {set VMEAccessServerPort 8015}

variable uri "urn:VMEAccessServer"
variable proxy "http://$VMEAccessServerHost:$VMEAccessServerPort/VMEAccessServer"

SOAP::create VMEAccessClient__DefineRegister -proxy $proxy -uri $uri -timeout 5000 \
     -name DefineRegister \
     -params {Register string Class string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__InquireRegisters -proxy $proxy -uri $uri -timeout 5000 \
     -name InquireRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create VMEAccessClient__ReadRegisterAttributes -proxy $proxy -uri $uri -timeout 5000 \
     -name ReadRegisterAttributes \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__ReadRegistersAttributes -proxy $proxy -uri $uri -timeout 5000 \
     -name ReadRegistersAttributes \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__DeleteRegister -proxy $proxy -uri $uri -timeout 5000 \
     -name DeleteRegister \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__DeleteRegisters -proxy $proxy -uri $uri -timeout 5000 \
     -name DeleteRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__WriteRegisterAttributes -proxy $proxy -uri $uri -timeout 5000 \
     -name WriteRegisterAttributes \
     -params {Register string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__WriteRegistersAttributes -proxy $proxy -uri $uri -timeout 5000 \
     -name WriteRegistersAttributes \
     -params {Pattern string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__WriteRegister -proxy $proxy -uri $uri -timeout 5000 \
     -name WriteRegister \
     -params {Register string Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__WriteRegisters -proxy $proxy -uri $uri -timeout 5000 \
     -name WriteRegisters \
     -params {Pattern string Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__InitialiseRegister -proxy $proxy -uri $uri -timeout 5000 \
     -name InitialiseRegister \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__InitialiseRegisters -proxy $proxy -uri $uri -timeout 5000 \
     -name InitialiseRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__ReadRegister -proxy $proxy -uri $uri -timeout 5000 \
     -name ReadRegister \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__ReadRegisters -proxy $proxy -uri $uri -timeout 5000 \
     -name ReadRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__InterfaceStatus -proxy $proxy -uri $uri -timeout 5000 \
     -name InterfaceStatus \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__AccessServerVerbose -proxy $proxy -uri $uri -timeout 5000 \
     -name AccessServerVerbose \
     -params {opt string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 



package provide VMEAccessClient 1.0
